aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorDmitry Baryshkov <dmitry.baryshkov@linaro.org>2020-12-29 06:35:10 +0300
committerDmitry Baryshkov <dmitry.baryshkov@linaro.org>2020-12-29 06:35:10 +0300
commita1695cea7e1ce7f42d295e4f8dac1cebf278aca0 (patch)
treee14c3325da3109ea93a4f1e6afac7b72bb222141
parent5c8fe583cce542aa0b84adc939ce85293de36e5e (diff)
Revert "gcc-plugins: simplify GCC plugin-dev capability test"
This reverts commit 1e860048c53ee77ee9870dcce94847a28544b753. New test breaks compilation in our CI, so as a quick measure just revert the offending commit, so that the kernel actually verifies that it can compile plugins.
-rwxr-xr-xscripts/gcc-plugin.sh19
-rw-r--r--scripts/gcc-plugins/Kconfig2
2 files changed, 20 insertions, 1 deletions
diff --git a/scripts/gcc-plugin.sh b/scripts/gcc-plugin.sh
new file mode 100755
index 000000000000..b79fd0bea838
--- /dev/null
+++ b/scripts/gcc-plugin.sh
@@ -0,0 +1,19 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+
+set -e
+
+srctree=$(dirname "$0")
+
+gccplugins_dir=$($* -print-file-name=plugin)
+
+# we need a c++ compiler that supports the designated initializer GNU extension
+$HOSTCC -c -x c++ -std=gnu++98 - -fsyntax-only -I $srctree/gcc-plugins -I $gccplugins_dir/include 2>/dev/null <<EOF
+#include "gcc-common.h"
+class test {
+public:
+ int test;
+} test = {
+ .test = 1
+};
+EOF
diff --git a/scripts/gcc-plugins/Kconfig b/scripts/gcc-plugins/Kconfig
index ab9eb4cbe33a..ae19fb0243b9 100644
--- a/scripts/gcc-plugins/Kconfig
+++ b/scripts/gcc-plugins/Kconfig
@@ -9,7 +9,7 @@ menuconfig GCC_PLUGINS
bool "GCC plugins"
depends on HAVE_GCC_PLUGINS
depends on CC_IS_GCC
- depends on $(success,test -e $(shell,$(CC) -print-file-name=plugin)/include/plugin-version.h)
+ depends on $(success,$(srctree)/scripts/gcc-plugin.sh $(CC))
default y
help
GCC plugins are loadable modules that provide extra features to the